local AceGUI = LibStub("AceGUI-3.0")

local tconcat, tremove, tinsert = table.concat, table.remove, table.insert

local function CreateDispatcher(argCount)
   local code = [[
        local xpcall, eh = ...
        local method, ARGS
        local function call() return method(ARGS) end
    
        local function dispatch(func, ...)
            method = func
            if not method then return end
            ARGS = ...
            return xpcall(call, eh)
        end
    
        return dispatch
    ]]
   
   local ARGS = {}
   for i = 1, argCount do ARGS[i] = "arg"..i end
   code = code:gsub("ARGS", tconcat(ARGS, ", "))
   return assert(loadstring(code, "safecall Dispatcher["..argCount.."]"))(xpcall, errorhandler)
end

local Dispatchers = setmetatable({}, {__index=function(self, argCount)
         local dispatcher = CreateDispatcher(argCount)
         rawset(self, argCount, dispatcher)
         return dispatcher
end})
Dispatchers[0] = function(func)
   return xpcall(func, errorhandler)
end

local function safecall(func, ...)
   return Dispatchers[select("#", ...)](func, ...)
end

AceGUI:RegisterLayout("PlayerUpgradeViewGroupLayout", function(content, children)
	
	if children[1] then
		children[1]:SetPoint("TOPLEFT", content)
		 if (children[2] and children[2].children[1] and children[2].children[1].scrollBarShown) then
			children[1]:SetPoint("RIGHT", content, -18, 0)
		 else
			children[1]:SetPoint("RIGHT", content)
		 end
	end
	
	if children[2] then
		children[2]:SetPoint("TOPLEFT", children[1].frame, "BOTTOMLEFT")
		children[2]:SetPoint("BOTTOMRIGHT") 
	end

    safecall(content.obj.LayoutFinished, content.obj, nil, nil)
end)